<script lang="ts">
    import { numberWithCommas } from "src/functions/comma-number";
    import { logoutSession } from "src/functions/logout";

    import { Page } from "src/page";
    import { pageSelectedStore, userProfileStore } from "src/store";
    import { fade } from "svelte/transition";

    let showMenu = false;
    let timeOutSubscribe: any = null;

    function onMouseOut() {
        timeOutSubscribe = setTimeout(function () {
            showMenu = false;
        }, 2000);
    }

    function onMouseOver() {
        showMenu = true;
        clearTimeout(timeOutSubscribe);
    }
</script>

<div class="flex items-center w-64">
    <div class="flex justify-end items-center text-gray-800 mx-2">
        <div
            on:click={() => {
                ($pageSelectedStore = Page.CART), (showMenu = false);
            }}
            on:mouseenter={() => (showMenu = true)}
            on:mouseleave={onMouseOut}
            class="relative text-gray-800"
        >
            <div
                role="button"
                aria-describedby="stardust-popover2"
                class="flex items-center"
            >
                <img
                    alt="profil"
                    src={$userProfileStore.image}
                    class="mx-auto object-cover rounded-full h-10 w-10 "
                />
                <p class="pl-2 text-white">
                    {$userProfileStore.fname}
                    {$userProfileStore.lname}
                </p>
            </div>
        </div>
    </div>

    {#if showMenu && $userProfileStore && Object.values(userProfileStore).length}
        <div
            class="flex justify-center rounded"
            transition:fade
            on:mouseenter={onMouseOver}
            on:mouseleave={() => (showMenu = false)}
        >
            <div
                class="origin-top-left absolute right-0 mt-5 mr-32 w-40 rounded shadow-lg bg-white ring-1 ring-black ring-opacity-5 focus:outline-none text-center"
                role="menu"
                aria-orientation="vertical"
                aria-labelledby="options-menu"
            >
                <div
                    class="relative w-0 h-0 leading-4 text-gray-800 border-transparent border-solid"
                    style="border-bottom: 10px solid rgb(255, 255, 255); border-left: 14px solid transparent; border-right: 14px solid transparent; bottom: 10px; left: 70px;"
                />

                <div on:click={() => ($pageSelectedStore = Page['PROFILE_MANAGE'])}
                    class="flex items-center pl-2 h-10 leading-4 text-gray-500 capitalize hover:bg-gray-500 hover:text-white cursor-pointer"
                >
                    บัญชีของฉัน
                </div>
                <div
                    on:click={() => ($pageSelectedStore = Page['BILLORDERS'])}
                    class="flex items-center pl-2 h-10 leading-4 text-gray-500 capitalize hover:bg-gray-500 hover:text-white cursor-pointer"
                >
                    การซื้อของฉัน
                </div>
                <div
                    on:click={logoutSession}
                    class="flex items-center pl-2 h-10 leading-4 text-gray-500 capitalize hover:bg-gray-500 hover:text-white cursor-pointer rounded-b"
                >
                    ออกจากระบบ
                </div>
            </div>
        </div>
    {/if}
</div>
